
/* $Id: c-dump.h,v 1.9 1994/12/10 04:15:23 mcadmin Exp $ */
/*
    Copyright (C) 1993 McGill University.
    Copyright (C) 1993 McCAT System Group.
    Copyright (C) 1993 Bhama Sridharan 
    Copyright (C) 1993 Justiani

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/******************************/
#ifndef __damcdump__
#define __damcdump__
/******************************/
#include "General.h"
#include "tree.h"
/*******
global variables for FLAGs
********/

/******************************/

/*****************************************************************/
#define STRING 1
#define NO_STRING 2
#define STRING_SET 1
#define NO_STRING_SET 2
#define VALUE 3
#define NOT_SET NULL
#define INDENT 0
#define NO_INDENT 1
#define INDENT_STEP 2
#define INDENT_size 41
#define NULL 0
#define NULL_STRING  "\0"


/** has the name of the input c file. this has been set in toplev.c     **/
extern char * ast_c_dump_base_name;

/** flag to determine whether or not c-dump is to be done		**/
extern int flag_c_dump;
/*************************************************************************/
/* THIS PROTOTYPING ARE ADDED FOR DEPENDENCE-TESTING MODULE              */
/*************************************************************************/
extern int dam_spit_dep;
/** flag to determine whether or not to dump read write set info	**/

extern int dump_read_write_sets;
extern int Alias_fast_dump;
extern int flag_connect_dump;
extern int flag_connect_indirect_dump;
extern int flag_connect_rw_dump;
extern int flag_heap_loop_invars;
extern int flag_heap_cse;
extern int Alias_indirect_dump; /* the flag to print the alias info only for
				   indirect refs in the program */
extern int dam_statistic;



void spit_all_c_code(tree n);
void spit_newline();
extern char *comment_string;

EXPORT int insert_in_struct_list();
EXPORT int get_int_cst();

void get_comment_string ( tree node );
int get_int_cst ( tree node );
int insert_in_struct_list ( tree node );
void print_file_or_string ( char *str );
void spit_all_c_code ( tree list );
void spit_cst ( tree node );
void spit_indent_string ( char *str );
void spit_name ( tree node );
void spit_newline ( void );
void spit_string ( char *str );
void spit_html_string ( char *str ); /* Rakesh: Dec 11/96 */
void spit_html_uid_string (FILE *dump_file, tree node); /* Rakesh: Dec 13/96 */
void spit_html_target_string(FILE *dump_file, tree node, char *node_name);
void spit_html_link_string(FILE *dump_file, tree node, char *node_name,
                           char *base_file_name, char *file_ext, char *target);
char * spit_type ( tree node, int typedef_flag ,int);
/*****************************************************************/
#endif
/*****************************************************************/

